<?php
/*
     Copyright (C) 2012  Likno Software

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Direct Access to this location is not allowed.');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.archive');
jimport('joomla.installer.helper');
jimport('joomla.installer.installer');

$option = $_REQUEST['option'];

class HTML_allwebmenus {

var $_ctrlDirHeader = "\x50\x4b\x01\x02";
var $_fileHeader = "\x50\x4b\x03\x04";
var $_data = null;
var $_metadata = null;

function defaultRoot() {
?>
	<fieldset style="padding: 5px; width:550px; border:1px solid #000099;display: block;">
	<legend style="color:#000099;">Select one of the following options</legend>
      	<ul>
			<li><a href="<?php echo JURI::base(); ?>/index.php?option=com_allwebmenus&controller=awmmenuextract">Generate the Menu Structure Code</a> of your Joomla Menu in order to load it in AllWebMenus program.</li>
			<li><a href="<?php echo JURI::base(); ?>/index.php?option=com_allwebmenus&controller=awmupload">Upload the AllWebMenus ZIP file</a> and have your menu appear in your Joomla pages.</li>
			<li><a href="http://www.likno.com/addins/joomla-menu.html" target="blank">Check for updates</a>.</li>
 		</ul>
	</fieldset>
<?php	
}

function nextLevel($database, $level, $parentid, $menutype, $category) {
	$curver=HTML_allwebmenus::getJoomlaVersion();
	if ($curver=='1.5') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent=" . $parentid . " ORDER BY ordering";
	} elseif ($curver=='1.6') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=" . $parentid . " ORDER BY ordering";
	} else {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=" . $parentid . " ORDER BY lft";
	}
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	$nbsp=str_repeat("&nbsp;",2*$level);
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	foreach(array_keys($rows) as $id) {
		$row =& $rows[$id];
		$sql="SELECT count(*) as countobjs from #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" . $row->id . " AND `category`=" . $category;
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		echo '<option value="' . $row->id;
		if ($myrows[0]->countobjs>0) {
			echo '" selected="selected';
		}
		if ($curver=='1.5') {
			echo '">' . $nbsp . '- ' . $row->name . '</option>';		
		} else {
			echo '">' . $nbsp . '- ' . $row->title . '</option>';		
		}
		HTML_allwebmenus::nextLevel($database, $level+1, $row->id, $menutype, $category);
	}
}

function menuExtractNext($option) {
	$curver=HTML_allwebmenus::getJoomlaVersion();
	$menutype = JRequest::getVar( 'menutype', 'none', 'POST', 'STRING', JREQUEST_ALLOWHTML );
	$database = null;
	$database =& JFactory::getDBO();
	$sql = "SELECT * FROM #__allwebmenus AS a WHERE a.menutype='" . $menutype . "' AND category=3";
	$database->setQuery($sql);
	$rows	= $database->loadObjectList();
	if (!$database->getErrorNum()) {
	} else {
		$rows = array();
	}
	if (count($rows)==0) {
		$selectedradio=0;
	} else {
		$selectedradio=$rows[0]->menuitemid;
	}
	$selectedradiomenutype=$selectedradio;
?>
	<form action="<?php echo $_SERVER['PHP_SELF']; ?>" name="adminForm" id="adminForm" method="post">
	<fieldset style="padding: 10px; width:500px; border:1px solid #000099;display:block;">
		<legend style="color:#000099;">Menu Type Options</legend>
		<table border="0" cellpadding="5" cellspacing="0" width="500">
			<tr>
				<td valign="top" class="key" width="500" colspan="2">
				Please select how you want your menu to behave:
				</td>
			</tr>
			<tr>
				<td valign="top" class="key" width="15">
				</td>
				<td width="485">
					<label for="menutype-Dynamic"><input id="menutype-Dynamic" type="radio" name="menutypeopt" value="1" onclick="awm_select_menu_type('Dynamic',0);awm_show_hide_select_options(0);"<?php if($selectedradio==1) echo ' checked="checked"'; ?> />"Dynamic" Menu Type</label><br>
					<label for="menutype-Mixed"><input id="menutype-Mixed" type="radio" name="menutypeopt" value="2" onclick="awm_select_menu_type('Mixed',0);awm_show_hide_select_options(0);"<?php if($selectedradio==2) echo ' checked="checked"'; ?> />"Mixed" Menu Type</label><br>
					<label for="menutype-Static"><input id="menutype-Static" type="radio" name="menutypeopt" value="0" onclick="awm_select_menu_type('Static',0);awm_show_hide_select_options(1);"<?php if($selectedradio==0) echo ' checked="checked"'; ?> />"Static" Menu Type</label>
				</td>
			</tr>
			<tr>
				<td valign="top" class="key" width="500" colspan="2">
					<div style="background-color:#F6F8DD;padding:10px; border:1px solid #0B55C4;margin-top:10px<?php if($selectedradio<>1) echo ';display:none'; ?>" id="AWM_menu_type_0_Dynamic_info">
						<p style="margin-top: 0px; padding-top: 0px;">You have selected to create a menu structure of "Dynamic Type".</p>
						<p>This means that the menu items in AllWebMenus will only be used for preview/styling purposes.</p>
						<p>In your actual pages these items will be ignored and the menu will be populated "dynamically" based on the plugin settings.</p>
						<p>The styles in AllWebMenus Style Editor will be used to form the actual menu items.</p>
					</div>
					<div style="background-color:#F6F8DD;padding:10px; border:1px solid #0B55C4;margin-top:10px<?php if($selectedradio<>2) echo ';display:none'; ?>" id="AWM_menu_type_0_Mixed_info">
						<p style="margin-top: 0px; padding-top: 0px;">You have selected to create a menu structure of "Mixed Type".</p>
						<p>This means that your menu will contain both the items you create within AllWebMenus ("static") and the items you import from Joomla ("dynamic").</p>
						<p>The imported Joomla items will use the styles of the AllWebMenus Style Editor but their actual content will be populated "dynamically" based on the plugin settings.</p>
						<p>The static items you create within AllWebMenus will be shown as is.</p>
					</div>
					<div style="background-color:#F6F8DD;padding:10px; border:1px solid #0B55C4;margin-top:10px<?php if($selectedradio<>0) echo ';display:none'; ?>" id="AWM_menu_type_0_Static_info">
						<p style="margin-top: 0px; padding-top: 0px;">You have selected to create a menu structure of "Static Type".</p>
						<p>Your menu will be edited (addition/removal/customization of items) within AllWebMenus only.</p>
						<p>Any changes on your online pages will not affect its items until you perform the "Save settings &amp; Generate Menu Structure Code" action and <strong>re-import</strong> to AllWebMenus.</p>
						<p>This allows for maximum customization, as your online menu will show all items and styles customized within AllWebMenus.</p>
					</div>
				</td>
			</tr>
		</table>
	</fieldset>

	<fieldset id="awm_select_options" style="padding: 10px; width:500px; border:1px solid #000099;display:<?php if($selectedradio<>0) echo 'none'; else echo 'block'; ?>;">
		<legend style="color:#000099;">Select Options</legend>
		<script type="text/javascript">
			function allselections(obj) {
				var e = document.getElementById(obj);
					e.disabled = true;
				var i = 0;
				var n = e.options.length;
				for (i = 0; i < n; i++) {
					e.options[i].disabled = true;
					e.options[i].selected = true;
				}
			}
			function disableselections(obj) {
				var e = document.getElementById(obj);
					e.disabled = true;
				var i = 0;
				var n = e.options.length;
				for (i = 0; i < n; i++) {
					e.options[i].disabled = true;
					e.options[i].selected = false;
				}
			}
			function enableselections(obj) {
				var e = document.getElementById(obj);
					e.disabled = false;
				var i = 0;
				var n = e.options.length;
				for (i = 0; i < n; i++) {
					e.options[i].disabled = false;
				}
			}
		</script>
		<script>
			function toggleHelp() {
				var x=document.getElementById("helpid");
				if(x.style.display=="none") x.style.display="block"; else x.style.display="none";
			}
			function awm_select_menu_type(x,t) {
				document.getElementById('AWM_menu_type_'+t+'_Dynamic_info').style.display="none";
				document.getElementById('AWM_menu_type_'+t+'_Mixed_info').style.display="none";
				document.getElementById('AWM_menu_type_'+t+'_Static_info').style.display="none";
				document.getElementById('AWM_menu_type_'+t+'_'+x+'_info').style.display="";
				document.getElementById('menutype-'+x).checked=true;
			}
			function awm_show_hide_select_options(x) {
				document.getElementById('awm_select_options').style.display=(x)?"block":"none";
			}
		</script>
		<table border="0" cellpadding="5" cellspacing="0" width="500">
					
<?php 
	$sql = "SELECT * FROM #__allwebmenus AS a WHERE a.menutype='" . $menutype . "' AND category=1";
	$database->setQuery($sql);
	$rows	= $database->loadObjectList();
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	if (count($rows)==0) {
		$selectedradio=1;
	} else {
		if (count($rows)==1) {
			if ($rows[0]->menuitemid==0){
				$selectedradio=0;
			} else {
				$selectedradio=2;
			}
		} else {
			$selectedradio=2;
		}
	}
	$selectedradiotext=$selectedradio;
?>					
					<tr>
						<td valign="top" class="key" width="500" colspan="2">
						<a href="#" onclick="toggleHelp()">What are the following options for?</a>
						<div id="helpid" style="background-color:#F6F8DD;display:none;padding:10px; border:1px solid #0B55C4;margin-top:10px">
The default "none" selection will import the following Joomla menu items in AllWebMenus using their Joomla-specified Text (or Link), as shown below. This is all you need in most cases.<br /><br />
However, a unique capability of AllWebMenus is that it also lets you edit the &lt;Item Text&gt; value (or &lt;Item Link&gt) of any imported items you like using completely different text or even formatted HTML!<br /><br />
This means that next time you are here to update your menu, you will have to be careful to exclude these items from being updated with their Joomla menu text (or Link), so that their edited custom values remain intact in your AllWebMenus project.<br />
						</div>
						</td>
					</tr>
					<tr>
						<td valign="top" class="key" width="500" colspan="2">
						Do not update <strong>&lt;Item Text&gt;</strong> value on AllWebMenus project for the following Items:
						</td>
					</tr>
					<tr>
						<td valign="top" class="key" width="15">
						</td>
						<td width="485">
							<label for="text-all"><input id="text-all" type="radio" name="textopt" value="all" onclick="allselections('selectionstext');"<?php if($selectedradio==0) echo 'checked="checked"'; ?> />All</label>
							<label for="text-none"><input id="text-none" type="radio" name="textopt" value="none" onclick="disableselections('selectionstext');"<?php if($selectedradio==1) echo 'checked="checked"'; ?> />None</label>
							<label for="text-select"><input id="text-select" type="radio" name="textopt" value="select" onclick="enableselections('selectionstext');"<?php if($selectedradio==2) echo 'checked="checked"'; ?> />Select Menu Item(s) from the List</label>
						</td>
					</tr>
					<tr>
						<td valign="top" class="key">							
						</td>
						<td>
							<select name="selectionstext[]" id="selectionstext" class="inputbox" size="15" multiple="multiple" style="width:300px">
							<optgroup label="<?php echo $menutype; ?>">
<?php 
	if ($curver=='1.5') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent=0 AND published=1 ORDER BY ordering";
	} else {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=1 AND published=1 ORDER BY ordering";
	}
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	foreach(array_keys($rows) as $id) {
		$row =& $rows[$id];
		$sql="SELECT count(*) as countobjs from #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" . $row->id . " AND category=1";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		echo '<option value="' . $row->id;
		if ($myrows[0]->countobjs>0) {
			echo '" selected="selected';
		}
		if ($curver=='1.5') {
			echo '">' . $row->name . '</option>';		
		} else {
			echo '">' . $row->title . '</option>';		
		}
		HTML_allwebmenus::nextLevel($database, 1, $row->id, $menutype, 1);
	}

?>
							</optgroup>
							</select>
						</td>

					</tr>
	</table>
<?php  
	if ($selectedradio==0) echo '<script type="text/javascript">allselections(\'selectionstext\');</script>';
	if ($selectedradio==1) echo '<script type="text/javascript">disableselections(\'selectionstext\');</script>';

	$sql = "SELECT * FROM #__allwebmenus AS a WHERE a.menutype='" . $menutype . "' AND category=2";
	$database->setQuery($sql);
	$rows	= $database->loadObjectList();
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	if (count($rows)==0) {
		$selectedradio=1;
	} else {
		if (count($rows)==1) {
			if ($rows[0]->menuitemid==0){
				$selectedradio=0;
			} else {
				$selectedradio=2;
			}
		} else {
			$selectedradio=2;
		}
	}
	$selectedradiolink=$selectedradio;
?>	
	<br /><br />
	<table border="0" cellpadding="5" cellspacing="0" width="500">
					<tr>
						<td valign="top" class="key" width="500" colspan="2">
						Do not update <strong>&lt;Item Link&gt;</strong> value on AllWebMenus project for the following Items:
						</td>
					</tr>
					<tr>
						<td valign="top" class="key" width="15">
						</td>
						<td width="485">
							<label for="link-all"><input id="link-all" type="radio" name="linkopt" value="all" onclick="allselections('selectionslink');"<?php if($selectedradio==0) echo 'checked="checked"'; ?> />All</label>
							<label for="link-none"><input id="link-none" type="radio" name="linkopt" value="none" onclick="disableselections('selectionslink');"<?php if($selectedradio==1) echo 'checked="checked"'; ?> />None</label>
							<label for="link-select"><input id="link-select" type="radio" name="linkopt" value="select" onclick="enableselections('selectionslink');"<?php if($selectedradio==2) echo 'checked="checked"'; ?> />Select Menu Item(s) from the List</label>
						</td>
					</tr>
					<tr>
						<td valign="top" class="key">							
						</td>
						<td>
							<select name="selectionslink[]" id="selectionslink" class="inputbox" size="15" multiple="multiple" style="width:300px">
							<optgroup label="<?php echo $menutype; ?>">
<?php 
	if ($curver=='1.5') {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent=0 AND published=1 ORDER BY ordering";
	} else {
		$sql = "SELECT m.* FROM #__menu AS m WHERE m.menutype='" . $menutype . "' AND parent_id=1 AND published=1 ORDER BY ordering";
	}
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	foreach(array_keys($rows) as $id) {
		$row =& $rows[$id];
		$sql="SELECT count(*) as countobjs from #__allwebmenus WHERE menutype='" . $menutype . "' AND menuitemid=" . $row->id . " AND category=2";
		$database->setQuery($sql);
		$myrows	= $database->loadObjectList('');
		echo '<option value="' . $row->id;
		if ($myrows[0]->countobjs>0) {
			echo '" selected="selected';
		}
		if ($curver=='1.5') {
			echo '">' . $row->name . '</option>';
		} else {
			echo '">' . $row->title . '</option>';
		}
		HTML_allwebmenus::nextLevel($database, 1, $row->id, $menutype, 2);
	}
?>
							</optgroup>
							</select>
						</td>

					</tr>
	</table>
	</fieldset>

	<table border="0" cellpadding="5" cellspacing="0" width="524">
      <tr>
		<td valign="top" class="key" width="27"></td>
		<td align="left"><br /><input name="button" type="button" value="Back" onclick="javascript:history.go(-1);" />&nbsp;
		<input name="reset" type="reset" value="Reset" onclick="ResetForm();">&nbsp;<input name="submit" type="Submit" value="Save settings &amp; Generate Menu Structure Code"></td>
	  </tr>
	</table>
<?php  
	if ($selectedradio==0) echo '<script type="text/javascript">allselections(\'selectionslink\');</script>';
	if ($selectedradio==1) echo '<script type="text/javascript">disableselections(\'selectionslink\');</script>';
?>	
<script type="text/javascript">
function ResetForm() {
<?php	
	switch ($selectedradiotext) {
		case 0:
			echo "\tdocument.getElementById('adminForm').textopt[0].checked=true;allselections('selectionstext');";
			break;
		case 1:
			echo "\tdocument.getElementById('adminForm').textopt[1].checked=true;disableselections('selectionstext');";
			break;
		case 2:		
			echo "\tdocument.getElementById('adminForm').textopt[2].checked=true;enableselections('selectionstext');";
			break;
	}
	switch ($selectedradiolink) {
		case 0:
			echo "\n\tdocument.getElementById('adminForm').linkopt[0].checked=true;allselections('selectionslink');";
			break;
		case 1:
			echo "\n\tdocument.getElementById('adminForm').linkopt[1].checked=true;disableselections('selectionslink');";
			break;
		case 2:
			echo "\n\tdocument.getElementById('adminForm').linkopt[2].checked=true;enableselections('selectionslink');";
			break;
	}
	switch ($selectedradiomenutype) {
		case 0:
			echo "\n\tdocument.getElementById('adminForm').menutypeopt[0].checked=true;awm_select_menu_type('Static',0);awm_show_hide_select_options(1);";
			break;
		case 1:
			echo "\n\tdocument.getElementById('adminForm').menutypeopt[1].checked=true;awm_select_menu_type('Dynamic',0);awm_show_hide_select_options(0);";
			break;
		case 2:		
			echo "\n\tdocument.getElementById('adminForm').menutypeopt[2].checked=true;awm_select_menu_type('Mixed',0);awm_show_hide_select_options(0);";
			break;
	}
?>	
	return true;
}
</script>
    
		<input type="hidden" name="option" value="<?php echo $option; ?>" />
		<input type="hidden" name="task" value="submit" />
		<input type="hidden" name="hidemainmenus" value="0" />
		<input type="hidden" name="client" value="<?php echo $client; ?>" />
		<input type="hidden" name="menutype" value="<?php echo $menutype; ?>" />
		<input type="hidden" name="controller" value="awmmenuextract" />
	</form>

<?php 
	HTML_allwebmenus::footer($option);
}



function menuExtractRoot( $option ) {
?>   
	<form action="<?php echo $_SERVER['PHP_SELF']; ?>" id="adminForm" method="post" name="adminForm">
	<fieldset style="padding: 10px; width:500px; border:1px solid #000099;display:block;">
	<legend style="color:#000099;"><b>Select Menu</b></legend>
	<table border="0" cellpadding="5" cellspacing="0" width="500">
      <tr>
		<td align="right" nowrap>
			<label for="imenutype">Please select the Joomla menu you wish to generate the Menu Structure Code for:</label>
		</td>
		<td valign="top" align="left" width="100%">
			<select name="menutype">
<?php
	$database = null;		
	$database =& JFactory::getDBO();
	$sql = 'SELECT distinct m.* FROM #__menu_types AS m, #__menu AS n WHERE m.menutype=n.menutype AND n.published=1';		
	$database->setQuery($sql);
	$rows	= $database->loadObjectList('id');
	if (!$database->getErrorNum()) {
	} else {
		$rows	= array();
	}
	foreach(array_keys($rows) as $id) {
		$row =& $rows[$id];
		$menutype = $row->menutype;
		echo "<option value=\"". $menutype . "\"";
		if ($menutype=='mainmenu') echo " selected=\"selected\"";
		echo ">" . $menutype . "</option>";
	}
?>			
			</select>
		</td>
	  </tr>	    
      <tr>
		<td align="center" colspan="2">
			<input name="button" type="button" value="Back" onclick="javascript:history.go(-1);" />&nbsp;<input name="submit" type="Submit" value="Go to Next Step" />
		</td>
	  </tr>
	</table>
	</fieldset>    
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="task" value="menuextractnext" />
	<input type="hidden" name="hidemainmenus" value="0" />
	<input type="hidden" name="client" value="<?php echo $client; ?>" />
	<input type="hidden" name="controller" value="awmmenuextract" />
	</form>

<?php 
	HTML_allwebmenus::footer($option);
}    

function uploadMenuRoot( $option ) {
?>
    
	<form enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF']; ?>" id="adminForm" method="post" name="adminForm">
	<fieldset style="padding: 10px; width:500px; border:1px solid #000099;display:block;">
	<legend style="color:#000099;"><b>Browse for AllWebMenus Joomla Menu ZIP file</b></legend>
	<table border="0" cellpadding="5" cellspacing="0" widths="670">
      <tr>
		<td valign="top">
			<label for="imenutype">Browse for the ZIP file that has been created by AllWebMenus<br />when you compiled your menu using the "Joomla Menu" Add-in...
			</label>
		</td>
	  </tr>	    
	  <tr>
		<td>
			<input class="input_box" id="install_package" name="install_package" type="file" size="57" /><input style="border:2px outset #808080" name="submit" type="Submit" value="Upload Menu ZIP File &amp; Install" />
		</td>
	  </tr>
      <tr>
		<td valign="top">
			<label for="imenutype">...and click the <strong>"Upload Menu ZIP File &amp; Install"</strong> button.</label>
			<br /><br /><hr /><br />
			<strong>Notes:</strong><br />Use the ZIP file as it has been created by the AllWebMenus Joomla Menu Add-in.<br />Do not change its filename, otherwise you may have problems.
		</td>
	  </tr>	    
	</table>
	</fieldset>    
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="task" value="uploadmenunext" />
	<input type="hidden" name="hidemainmenus" value="0" />
	<input type="hidden" name="client" value="<?php echo $client; ?>" />
	<input type="hidden" name="controller" value="awmupload" />
	</form>

<?php 
	HTML_allwebmenus::footer($option);
}    

function uploadMenuNext( $option ) {
	$curver=HTML_allwebmenus::getJoomlaVersion();
	if ($curver=='1.5') {
		global $mainframe;
	} else {
		$mainframe = JFactory::getApplication();
	}
	$userfile = JRequest::getVar( 'install_package', null, 'files', 'array' );
	$filesize=$userfile['size'];
	$filename=$userfile['name'];
	$filetmpname=$userfile['tmp_name'];
	$fileerror=$userfile['error'];
	$menuname="";
	
	$error_occured=0;
	
	$http_host = substr(JURI::base(),0,strpos(JURI::base(),"administrator")); 	
	if ($filesize==0 && $error_occured==0) {
		$mainframe->enqueueMessage( "Error when uploading AllWebMenus Compiled Menu ZIP File:" , 'error' );
		$error_occured=1;
	} 
	
	if (substr(strtolower($filename),0,3)!="awm" && strlen($filename)>7 && $error_occured==0) {
		$mainframe->enqueueMessage( "Error when uploading AllWebMenus Compiled Menu ZIP File:" , 'error' );
		$error_occured=2;
	} else {
		$menuname=substr($filename,3,strlen($filename)-7);
	}
	
	if ($menuname=="" && $error_occured==0) {
		$mainframe->enqueueMessage( "Error when uploading AllWebMenus Compiled Menu ZIP File:" , 'error' );
		$error_occured=3;
	} 
	if ($error_occured==0) {	
		$database = null;		
		$database =& JFactory::getDBO();
		$sql = "SELECT * FROM #__plugins AS a WHERE a.element='awm" . $menuname . "'";
		$database->setQuery($sql);
		$rows	= $database->loadObjectList();
		if (!$database->getErrorNum()) {
		} else {
			$rows	= array();
		}
		if (count($rows)==0) {
			$pluginexists=0;
		} else {
			$pluginexists=1;
		}

		$sql = "SELECT * FROM #__modules AS a WHERE a.module='mod_awm_" . $menuname . "'";
		$database->setQuery($sql);
		$rows	= $database->loadObjectList();
		if (!$database->getErrorNum()) {
		} else {
			$rows	= array();
		}
		if (count($rows)==0) {
			$moduleexists=0;
		} else {
			$moduleexists=1;
		}

		if (!(bool) ini_get('file_uploads')) {
			$mainframe->enqueueMessage( "No file upload can be done!" , 'error' );			
			return false;
		}
		if (!extension_loaded('zlib')) {
			$mainframe->enqueueMessage( "No zlib extension found!" , 'error' );			
			return false;
		}
		if (!is_array($userfile) ) {
			$mainframe->enqueueMessage( "No file selected!" , 'error' );			
			return false;
		}
		if ( $userfile['error'] || $userfile['size'] < 1 )
		{
			$mainframe->enqueueMessage( "No file or empty file has been selected!" , 'error' );			
			return false;
		}
		$config =& JFactory::getConfig();
		$tmp_dest 	= $config->getValue('config.tmp_path').DS.$userfile['name'];
		$tmp_src	= $userfile['tmp_name'];
		if ($tmp_dest!=$tmp_src) {
			$uploaded = JFile::upload($tmp_src, $tmp_dest);
			if (!$uploaded) {
				$mainframe->enqueueMessage( "AllWebMenus Component can not upload the following file" , 'error' );			
				$mainframe->enqueueMessage( $tmp_src , 'error' );			
				$mainframe->enqueueMessage( "to the following destination"  , 'error' );			
				$mainframe->enqueueMessage( $tmp_dest , 'error' );			
				return;
			}
		}
		$ret=@ chmod($tmp_dest, octdec('0777'));
		$package = HTML_allwebmenus::unpack($tmp_dest);
		if (!$package) {
			$mainframe->enqueueMessage( "AllWebMenus Component can not unpack the following file:" , 'error' );			
			$mainframe->enqueueMessage( $tmp_dest , 'error' );			
			return;
		}
		if ($pluginexists==0) {
			$installer =& JInstaller::getInstance();
			if (!$installer->install($package['dir'])) {
				$result = false;
			} else {
				$result = true;
			}
		}
		
		$copies2 = JFile::copy($package['extractdir'].DS.'www'.DS.'awm'.$menuname.'.php',JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname.'.php');
		$copies3 = JFile::copy($package['extractdir'].DS.'awm'.$menuname.'.xml',JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname.'.xml');
		$copies4 = JFolder::copy($package['extractdir'].DS.'www'.DS.'awm'.$menuname,JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname,'',true);
		$copies1 = JFile::copy(JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname.DS.$menuname.'.js',JPATH_SITE.DS.$menuname.'.js');

		$newfolder=$package['dir'].DS."mod";
		$modulefileexists=JFile::exists($newfolder.DS."index.html");
		if ($modulefileexists) {
			if ($moduleexists==0) {
				$installer =& JInstaller::getInstance();
				if (!$installer->install($newfolder)) {
					$result = false;
				} else {
					$sql = "UPDATE #__modules set published=1 WHERE module='mod_awm_" . $menuname . "'";
					$database->setQuery($sql);
					$database->query();		
					$sql = "UPDATE #__modules set showtitle=0 WHERE module='mod_awm_" . $menuname . "'";
					$database->setQuery($sql);
					$database->query();						
					$result = true;
				}		
			} else {
				$copies5 = JFile::copy($package['extractdir'].DS.'mod'.DS.'mod_awm_'.$menuname.'.php',JPATH_SITE.DS.'modules'.DS.'mod_awm_'.$menuname.DS.'mod_awm_'.$menuname.'.php');
			}
		}
		
		if (!is_file($package['packagefile'])) {
			$config =& JFactory::getConfig();
			$package['packagefile'] = $config->getValue('config.tmp_path').DS.$package['packagefile'];
		}
		HTML_allwebmenus::cleanupInstall($package['packagefile'], $package['extractdir']);		

		if (!$copies1) {
			$mainframe->enqueueMessage( "AllWebMenus Component could not copy file" , 'error' );
			$mainframe->enqueueMessage( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname.DS.$menuname.'.js', 'error' );
			$mainframe->enqueueMessage( "Please copy manually the above file to directory", 'error' );
			$mainframe->enqueueMessage( JPATH_SITE.DS, 'error' );
			$mainframe->enqueueMessage( "or change permissions of the above directory to 777 and try again.", 'error' );
		}

		$menufilename=JPATH_SITE.DS.'plugins'.DS.'system'.DS.'awm'.$menuname.DS.$menuname.'.js';
		$menufilenameexists=JFile::exists($menufilename);
		
		if ($menufilenameexists) {
			$menufile = fopen($menufilename, 'r');		
			$mfile = fread($menufile, filesize($menufilename));
			$bNo = explode('awmLibraryBuild=', $mfile);
			$bNo = explode(';', $bNo[1]);
			$buildNo = $bNo[0];
			$hNo = explode('awmHash=\'', $mfile);
			$hNo = explode('\'', $hNo[1]);
			$HashNo = $hNo[0];
			$params = "build=$buildNo&plugin=joomla&hash=$HashNo&rand=". rand(1,10000) ."&domain=". JURI::base();
		}
?>
<p style="margin:3px">Your AllWebMenus menu has been successfully uploaded and installed.
<p style="margin:3px">You will now be able to view the menu on your Joomla website.
<p style="margin:3px">If you do not see the menu, please check one of the following:
<ul style="margin:0px">
<li><p style="margin:3px">You forgot to enable the AllWebMenus menu through the "Plugin Manager".
<li><p style="margin:3px">Your menu is positioned "Relative to an Element" (or Image) but you did not specify an available "Element ID" or "Image Name" in the <Positioning> property of AllWebMenus.
</ul>
<?php		
		$AWM_Text="";
		if (function_exists('curl_init') && $menufilenameexists) {
			$awm_tmp = geturl($HashNo, $params);
			if (strlen($awm_tmp) > 2 ) {
				$AWM_Text = "<br /><strong>WARNING!</strong><br />" . $awm_tmp;
			}
		}
		echo $AWM_Text;
		if ($copies1) {
			$mainframe->enqueueMessage( "Successful upload/installation" );
		} else {
			$mainframe->enqueueMessage( "Almost Successful upload/installation. Please read the errors above." , 'notice' );
		}
	} else {
		echo "There was an error when you tried to upload your AllWebMenus Compiled Menu ZIP File.<br />";
		switch ($error_occured) {
			case 1:
				echo "It looks like you have not selected any file, or the size of the file is zero (0).<br/ >";
				break;
			case 2:
				echo "It looks like you are trying to upload a file which was not created by AllWebMenus Joomla Menu Add-in,<br />or you have renamed the produced ZIP file.<br/ >";
				echo "<br />Try to upload only a ZIP file that has been created by the AllWebMenus Joomla Menu Add-in,<br />and do not change its filename, otherwise you may have problems.<br/ >";
				break;
			case 3:
				echo "It looks like you are trying to upload a file which was not created by AllWebMenus Joomla Menu Add-in,<br />or you have renamed the produced ZIP file.<br/ >";
				echo "<br />Try to upload only a ZIP file that has been created by the AllWebMenus Joomla Menu Add-in,<br />and do not change its filename, otherwise you may have problems.<br/ >";
				break;		
		}		
?>	
		<br />Please <strong><a href="<?php echo JURI::base(); ?>/index.php?option=com_allwebmenus&controller=awmupload">try again</a></strong>.
<?php
	}
?>
    
<?php 
	HTML_allwebmenus::footer($option);
}

function menuExtractFinish($option, $XMLString) {
	$curver=HTML_allwebmenus::getJoomlaVersion();
	if ($curver=='1.5') {
		global $mainframe;
	} else {
		$mainframe = JFactory::getApplication();
	}
	$mainframe->enqueueMessage( "Success! The Menu Structure Code of your Joomla menu has been generated below." );
	$mainframe->enqueueMessage( "&nbsp;" );
	$mainframe->enqueueMessage( "Now copy and paste the code to your AllWebMenus:" );

?>
<table border="0" cellpadding="5" cellspacing="0" width="100">
	<tr>
		<td align="center">
		<span style="font-size:large;text-decoration:underline;font-weight:bold">Menu Structure Code</span>
		</td>
	</tr>
	<tr>
	<td>
<textarea cols="80" rows="12" id="loginfo" name="loginfo"><?php echo htmlspecialchars($XMLString, ENT_QUOTES, 'UTF-8'); ?>
</textarea>
	</td>
	</tr>
<tr>
<td>
<p style="margin:3px">- Press <strong>Ctrl+C</strong> to copy the above code</p>
<p style="margin:3px">- Switch to the AllWebMenus desktop application</p>
<p style="margin:3px">- Open the <span style="font-style:italic">"Add-ins</span> -&gt; <span style="font-style:italic">Joomla Menu</span> -&gt; <span style="font-style:italic">Import/Update Menu Structure from Joomla"</span> form</p>
<p style="margin:3px">- Paste the above copied "Menu Structure Code"</p>
<p style="margin:3px">- Configure further your menu (styles, etc.) through the AllWebMenus properties</p>
</td>
</tr>
</table>
<script type='text/javascript'>var t=document.getElementById('loginfo');t.select();t.focus();</script>
<?php
}

function footer($option){
/*	
		print "<div align=\"left\" style=\"clear:both;\"><a href=\"index.php?option=".$option."&task=updatecheck\">Check for update</a><br />Copyright 2008 
		<a target=\"_blank\" href=\"http://www.likno.com/addins/joomla-menu.html\">Likno Software</a>.</div>";
*/
}

function unpack($p_filename)
{
		$archivename = $p_filename;
		$tmpdir = uniqid('install_');
		$extractdir = JPath::clean(dirname($p_filename).DS.$tmpdir);
		$archivename = JPath::clean($archivename);
		$result = HTML_allwebmenus::extract( $archivename, $extractdir);
		if ( $result === false ) {
			return false;
		}
		$retval['extractdir'] = $extractdir;
		$retval['packagefile'] = $archivename;
		$dirList = array_merge(JFolder::files($extractdir, ''), JFolder::folders($extractdir, ''));
		if (count($dirList) == 1)
		{
			if (JFolder::exists($extractdir.DS.$dirList[0]))
			{
				$extractdir = JPath::clean($extractdir.DS.$dirList[0]);
			}
		}
		$retval['dir'] = $extractdir;
		if ($retval['type'] = JInstallerHelper::detectType($extractdir))
		{
			return $retval;
		} else
		{
			return false;
		}
}

function cleanupInstall($package, $resultdir)
{
		$config =& JFactory::getConfig();
		if (is_dir($resultdir)) {
			JFolder::delete($resultdir);
		}
		if (is_file($package)) {
			JFile::delete($package);
		} elseif (is_file(JPath::clean($config->getValue('config.tmp_path').DS.$package))) {
			JFile::delete(JPath::clean($config->getValue('config.tmp_path').DS.$package));
		}
}

function extract( $archivename, $extractdir)
{
		$result = false;
		$adapter =& HTML_allwebmenus::getAdapter('zip');
		if ($adapter) {
			$result = $adapter->extract($archivename, $extractdir);
		}
		if (! $result || JError::isError($result)) {
			return false;
		}
		return true;
}

function &getAdapter($type)
{
		static $adapters;
		if (!isset($adapters)) {
			$adapters = array();
		}
		if (!isset($adapters[$type]))
		{
			$class = 'JArchiveZipAwm';
			if (!class_exists($class))
			{
				$path = dirname(__FILE__).DS.'library'.DS.'zipawm.php';
				if (file_exists($path)) {
					require_once($path);
				} else {
					JError::raiseError(500,JText::_('Unable to load archive'));
				}
			}
			$adapters[$type] = new $class();
		}
		return $adapters[$type];
}

function getJoomlaVersion() {
	$version = new JVersion;
	return substr($version->getShortVersion(),0,3);
}	
}
?>
